--  This software is distributed under the following license know as
--  The modified BSD license
--
--  Redistribution and use in source and binary forms, with or without
--  modification, are permitted provided that the following conditions are
--  met:

--      (1) Redistributions of source code must retain the above copyright
--      notice, this list of conditions and the following disclaimer. 

--      (2) Redistributions in binary form must reproduce the above copyright
--      notice, this list of conditions and the following disclaimer in
--      the documentation and/or other materials provided with the
--      distribution.  
    
--      (3)The name of the author may not be used to
--      endorse or promote products derived from this software without
--      specific prior written permission.

--  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
--  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
--  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
--  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
--  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
--  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
--  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
--  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
--  POSSIBILITY OF SUCH DAMAGE.

package body Scalada.Intervals is

   function Interval_Value(Of_The_quality : Quality_Interval) return Notes_Interval is
   begin
      return Quality_Interval'Pos(Of_The_Quality);
   end Interval_Value;

   function Quality_Of(Interval : Notes_Interval) return Quality_Interval
   is
   begin
      return Quality_Interval'Val(Interval);
   end Quality_Of;

   function Quality_Of(Note : in Notes.Note; To_Tonic : in Notes.Note) return Quality_Interval
   is
      use Notes;
      Diff : Integer;
   begin
      Diff := Notes.Note'Pos(Note) - Notes.Note'Pos(To_tonic);

      if Diff < 0 then
         Diff := Integer(Notes_Interval'Last) + Diff + 1;
      end if;

      return Quality_Interval'Val(diff);
   end Quality_Of;

   function Get_Note(Quality : Quality_Interval; Of_Tonic : Notes.Note) return Notes.Note
   is
      Index : Notes.Note_Index;
      use Notes;
   begin
      Index := Note_Index(Interval_Value(Quality)) + Note'Pos(Of_Tonic);

      return Note'Val(Index);
   end Get_Note;

end Scalada.Intervals;
