--  This software is distributed under the following license know as
--  The modified BSD license
--
--  Redistribution and use in source and binary forms, with or without
--  modification, are permitted provided that the following conditions are
--  met:

--      (1) Redistributions of source code must retain the above copyright
--      notice, this list of conditions and the following disclaimer. 

--      (2) Redistributions in binary form must reproduce the above copyright
--      notice, this list of conditions and the following disclaimer in
--      the documentation and/or other materials provided with the
--      distribution.  
    
--      (3)The name of the author may not be used to
--      endorse or promote products derived from this software without
--      specific prior written permission.

--  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
--  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
--  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
--  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
--  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
--  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
--  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
--  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
--  POSSIBILITY OF SUCH DAMAGE.

with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package body Scalada.Notes.Text_IO is

   Latin_Names : constant array(Note) of UnBounded_String := ( To_Unbounded_String("Do"),
                                                               To_Unbounded_String("Réb"),
                                                               To_Unbounded_String("Ré"),
                                                               To_Unbounded_String("Mib"),
                                                               To_Unbounded_String("Mi"),
                                                               To_Unbounded_String("Fa"),
                                                               To_Unbounded_String("Solb"),
                                                               To_Unbounded_String("Sol"),
                                                               To_Unbounded_String("Lab"),
                                                               To_Unbounded_String("La"),
                                                               To_Unbounded_String("Sib"),
                                                               To_Unbounded_String("Si"));

   International_Names : constant array(Note) of UnBounded_String := ( To_Unbounded_String("C"),
                                                                       To_Unbounded_String("Db"),
                                                                       To_Unbounded_String("D"),
                                                                       To_Unbounded_String("Eb"),
                                                                       To_Unbounded_String("E"),
                                                                       To_Unbounded_String("F"),
                                                                       To_Unbounded_String("Gb"),
                                                                       To_Unbounded_String("G"),
                                                                       To_Unbounded_String("Ab"),
                                                                       To_Unbounded_String("A"),
                                                                       To_Unbounded_String("Bb"),
                                                                       To_Unbounded_String("B")
                                                                      );

   function Latin_Name(The_Note : Note) return String is
   begin
      return To_String(Latin_Names(The_Note));
   end Latin_Name;

   function International_Name(The_Note : Note) return String is
   begin
      return To_String(International_Names(The_Note));
   end International_Name;

end Scalada.Notes.Text_IO;
