--  This software is distributed under the following license know as
--  The modified BSD license
--
--  Redistribution and use in source and binary forms, with or without
--  modification, are permitted provided that the following conditions are
--  met:

--      (1) Redistributions of source code must retain the above copyright
--      notice, this list of conditions and the following disclaimer. 

--      (2) Redistributions in binary form must reproduce the above copyright
--      notice, this list of conditions and the following disclaimer in
--      the documentation and/or other materials provided with the
--      distribution.  
    
--      (3)The name of the author may not be used to
--      endorse or promote products derived from this software without
--      specific prior written permission.

--  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
--  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
--  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
--  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
--  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
--  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
--  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
--  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
--  POSSIBILITY OF SUCH DAMAGE.

with Scalada.Scales; use Scalada.Scales;
with Scalada.Notes; use Scalada.Notes;
with Scalada.Chords; use Scalada.Chords;
with Scalada.NamedStructures; use Scalada.NamedStructures;

package Scalada.Scale_Finder is
   -- Matching scale with tonic
   type Matching_Scale is record
      Tonic : Notes.Note;
      Matching_Scale : Scale;
   end record;

   -- Specific chord
   type Specific_Chord is record
      Tonic : Notes.Note;
      Chord_Structure : Chords.Chord;
   end record;

   -- Returned array for matching scales
   type Matching_Scales_Array is array(Natural range <>) of Matching_Scale;

   -- Array of chords to select a scale
   type Chords_Array is array(Natural range <>) of Specific_Chord;

   -- Function that returns matching scales
   function Matching_Scales (Included_notes : in Set_Of_Notes) return Matching_Scales_Array;

   -- Function that returns scales containing the provided set
   function Containing_Scales(Included_Notes : in Set_Of_Notes) return Matching_Scales_Array;

   -- Function that returns scales containing the provided chords
   function Containing_Scales(Included_Chords : in Chords_Array) return Matching_Scales_Array;

end Scalada.Scale_Finder;
