--  This software is distributed under the following license know as
--  The modified BSD license
--
--  Redistribution and use in source and binary forms, with or without
--  modification, are permitted provided that the following conditions are
--  met:

--      (1) Redistributions of source code must retain the above copyright
--      notice, this list of conditions and the following disclaimer. 

--      (2) Redistributions in binary form must reproduce the above copyright
--      notice, this list of conditions and the following disclaimer in
--      the documentation and/or other materials provided with the
--      distribution.  
    
--      (3)The name of the author may not be used to
--      endorse or promote products derived from this software without
--      specific prior written permission.

--  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
--  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
--  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
--  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
--  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
--  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
--  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
--  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
--  POSSIBILITY OF SUCH DAMAGE.

with Ada.Text_IO; use Ada.Text_IO;
with Scalada.Intervals.Text_IO; use Scalada.Intervals.Text_IO;
with Scalada.Notes.Text_IO; use Scalada.Notes.Text_IO;

package body Scalada.Scales.Text_IO is

   -------------
   -- Display --
   -------------
   procedure Display (The_Scale:in Set_Of_Notes) is
   begin
      Put_Line("Scale for " & Latin_Name(The_Scale(1)));
      for Index in The_Scale'Range loop
         Put_Line("Degree " & Positive'Image(Index) & " as "& Get_Standard_Small_Name(Quality_Of(The_Scale(Index), The_Scale(1))) & " : " & Latin_Name(The_Scale(Index)) & " or " &
International_Name(The_Scale(Index)));
      end loop;
   end Display;

   procedure Display (The_Scale:in Scale) is
      Qualities : Quality_Interval_Array := Get_Structure(The_Scale);
   begin
      Put_Line("Scale " & Get_Name(The_Scale));
      for Index in Qualities'Range loop
         Put(Get_Standard_Small_Name(Qualities(Index)) & " ");
      end loop;
      New_Line;
   end Display;

end Scalada.Scales.Text_IO;
