with Ada.Numerics.Generic_Elementary_Functions;
with Ada.Numerics; use Ada.Numerics;

with Cairo; use Cairo;
with Gdk.Cairo; use Gdk.Cairo;


with Glib; use Glib;

separate(Scalada.Fretboard_Panels)
procedure Draw_Board(Panel : access Fretboard_Panel_Record'Class) is
   package Func_Pkg is new Ada.Numerics.Generic_Elementary_Functions(GDouble);
   use Func_Pkg;
   
   Ctxt : Cairo_Context := Gdk.Cairo.Create(Get_Window(Panel.Drawing));
   Reparti : GDouble := GDouble(Get_Allocation_Height(Panel.Drawing)) * (1.0 - 0.7) / 2.0;
begin
   -- use Ctxt
   arc(ctxt, GDouble(Get_Allocation_X(Panel.Drawing) + Get_Allocation_Width(Panel.Drawing)) / 2.0,
       GDouble(Get_Allocation_Y(Panel.Drawing) + Get_Allocation_Height(Panel.Drawing)) / 2.0, 
       GDouble(Get_Allocation_Height(Panel.Drawing)) / 2.0, 
       0.0, 
       2.0 * PI);
   Move_To(Ctxt, 0.0, 0.0);
   Line_To(Ctxt, GDouble(Get_Allocation_Width(Panel.Drawing)) , Reparti);
   Move_To(Ctxt, 0.0, GDouble(Get_Allocation_Height(Panel.Drawing)));
   Line_To(Ctxt, GDouble(Get_Allocation_Width(Panel.Drawing)) ,  GDouble(Get_Allocation_Height(Panel.Drawing)) - Reparti);
   Set_Source_Rgb(Ctxt, 1.0, 1.0, 1.0);
   Fill_Preserve(Ctxt);
   Set_Source_Rgb(Ctxt, 0.0, 0.0, 0.0);
   Stroke(Ctxt);
   Destroy(Ctxt);
end Draw_Board;
