with Gdk.Gc; use Gdk.Gc;
with Gdk.Window; use Gdk.Window;
with Ada.Numerics.Generic_Elementary_Functions;
with Ada.Text_Io; use Ada.Text_Io;

with Glib; use Glib;

separate(Scalada.Fretboard_Panels)
procedure Draw_Board(Panel : access Fretboard_Panel_Record'Class) is
   package Func_Pkg is new Ada.Numerics.Generic_Elementary_Functions(GDouble);
   use Func_Pkg;

   Ctxt : Gdk_GC;
   Window : Gdk_Window := Get_Window(Panel.Drawing);
   Width : GInt := Get_Allocation_Width(Panel.Drawing);
   Height : GInt := Get_Allocation_Height(Panel.Drawing);
   Spare_Space : GInt := GInt((GDouble(Height) * 0.3) / 2.0);
   Total_Length : GDouble := GDouble(Width) * (2.0**(24.0/12.0));
begin
   Gdk_New(Ctxt, Window);
   Get_Size(Window, Width, Height);
   Set_Line_Attributes(Ctxt,
                       2,
                       Line_Solid,
                       Cap_Round,
                       Join_Bevel);
   Draw_Line(Window, Ctxt, Width, 0, 0, Spare_Space);
   Draw_Line(Window, Ctxt, 0, Height - Spare_Space, Width, Height);

   for Fret_Number in 1..24 loop
      declare
         Axis : Gint := Gint(GDouble(Total_Length)/(2.0)**(GDouble(Fret_Number)/12.0));
      begin
         Draw_Line(Window, Ctxt, (Gint(Total_Length) - Axis)/3 ,0, (Gint(Total_Length) - Axis)/3, Height);
         Put_Line(Gint'Image(Width) & " " & Gint'Image(Gint(Total_length)) & " " & Gint'Image(Axis));
      end;
   end loop;

   Destroy(Ctxt);
end Draw_Board;
