--  This software is distributed under the following license know as
--  The modified BSD license
--
--  Redistribution and use in source and binary forms, with or without
--  modification, are permitted provided that the following conditions are
--  met:

--      (1) Redistributions of source code must retain the above copyright
--      notice, this list of conditions and the following disclaimer. 

--      (2) Redistributions in binary form must reproduce the above copyright
--      notice, this list of conditions and the following disclaimer in
--      the documentation and/or other materials provided with the
--      distribution.  
    
--      (3)The name of the author may not be used to
--      endorse or promote products derived from this software without
--      specific prior written permission.

--  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
--  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
--  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
--  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
--  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
--  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
--  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
--  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
--  POSSIBILITY OF SUCH DAMAGE.

with Gtk.Frame;
with Gtk.Check_Button; use Gtk.Check_Button;
with Gtk.Tree_View; use Gtk.Tree_View;
with Gtk.List_Store; use Gtk.List_Store;
with Scalada.Notes_Panels; use Scalada.Notes_Panels;

with Glib; use Glib;

with Scalada.Notes; use Scalada.Notes;
with Scalada.NamedStructures; use Scalada.NamedStructures;
with Scalada.Scale_Finder; use Scalada.Scale_Finder;

package Scalada.Scale_Finder_Panels is

   type Scale_Finder_Panel_Record is new Gtk.Frame.Gtk_Frame_Record with private;

   type Scale_Finder_Panel is access all Scale_Finder_Panel_Record'Class;

   procedure Gtk_New (Panel : out Scale_Finder_Panel);
   procedure Initialize (Panel : access Scale_Finder_Panel_Record'Class; Label : UTF8_String :="");

   -- Notes selected
   function Selected_Notes(Panel : in Scale_Finder_Panel_Record) return Set_Of_Notes;

   -- Scale selected
   function Selected_Scale(Panel : in Scale_Finder_Panel_Record) return Matching_Scale;

   -- Signal sent when one of the checkbox is clicked
   Signal_Notes_Changed : constant Glib.Signal_Name := "notes_changed";

   -- Signal sent when one scale was selected
   Signal_Scale_Selected : constant Glib.Signal_Name := "scale_selected";

   -- exception when asking for the selected scale and no is selected
   No_Scale_Selected : exception;

private

   type Scale_Finder_Panel_Record is new Gtk.Frame.Gtk_Frame_Record with
      record
         Notes_Panel_Widget : Notes_Panel;
         Match_Button : Gtk_Check_Button;
         Store : Gtk_List_Store;
         Tree : Gtk_Tree_View;
      end record;

end Scalada.Scale_Finder_Panels;
